/*******************************************************************************
***  This file is part of Geometry.                                          ***
***                                                                          ***
***  Copyright (C) 2024                                                      ***
***  John Schneiderman <Licencing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Lesser General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Lesser General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include "Cartesian.h"

#include <stdio.h>
// printf
// scanf


#define CARTESIAN_VALUE_FORMAT "%i"

int scanfCoordinateAxes(struct CoordinateAxes* location)
{
	const int arguemntsAssigned = scanf(CARTESIAN_VALUE_FORMAT, &location->value_);
	return arguemntsAssigned;
}

int scanfPoint(struct Point* location)
{
	struct CoordinateAxes abscissa = {0};
	const int arguemntsAssignedAbscissa = scanfCoordinateAxes(&abscissa);

	if (arguemntsAssignedAbscissa <= 0)
		return arguemntsAssignedAbscissa;

	struct CoordinateAxes ordinate = {0};
	const int arguemntsAssignedOrdinate = scanfCoordinateAxes(&ordinate);

	if (arguemntsAssignedOrdinate <= 0)
		return arguemntsAssignedOrdinate;

	location->abscissa_ = abscissa;
	location->ordinate_ = ordinate;
	return arguemntsAssignedAbscissa + arguemntsAssignedOrdinate;
}

int printfCoordinateAxes(const struct CoordinateAxes location)
{
	return printf(CARTESIAN_VALUE_FORMAT, location.value_);
}

int printfPoint(const struct Point location)
{
	const int openBytes = printf("(");

	if (openBytes <= 0)
		return openBytes;

	const int abscissaBytes = printfCoordinateAxes(location.abscissa_);

	if (abscissaBytes <= 0)
		return abscissaBytes;

	const int sepBytes = printf(", ");

	if (sepBytes <= 0)
		return sepBytes;

	const int ordinateBytes = printfCoordinateAxes(location.ordinate_);

	if (ordinateBytes <= 0)
		return ordinateBytes;

	const int closeBytes = printf(")");

	if (closeBytes <= 0)
		return closeBytes;

	return openBytes + abscissaBytes + sepBytes + ordinateBytes + closeBytes;
}

void movePointHorizontally(struct Point* location, const CARTESIAN_VALUE_TYPE amount)
{
	location->abscissa_.value_ += amount;
}

void movePointVertically(struct Point* location, const CARTESIAN_VALUE_TYPE amount)
{
	location->ordinate_.value_ += amount;
}

void movePoint(
        struct Point* location,
        const CARTESIAN_VALUE_TYPE horizontalAmount,
        const CARTESIAN_VALUE_TYPE verticalAmount
)
{
	movePointHorizontally(location, horizontalAmount);
	movePointVertically(location, verticalAmount);
}
